/*
Created using Microdesk MyGeneration NHibernate Template v1.1
[based on MyGeneration/Template/NHibernate (c) by Sharp 1.4]
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace DataTransfer
{

	/// <summary>
	/// ICustomer interface for NHibernate mapped table 'Customer'.
	/// </summary>
	public interface ICustomer
	{
		#region Public Properties
		
		int CustomerId
		{
			get ;
			set ;
			  
		}
		
		string Firstname
		{
			get ;
			set ;
			  
		}
		
		string Lastname
		{
			get ;
			set ;
			  
		}
		
		int Version
		{
			get ;
			set ;
			  
		}
		
		OrderCollection Orders_OrderCollection
		{
			get ;
			set ;
		}
		
		
		IList<Order> Orders
		{
			get ;
			set ;
			  
		}
		
		bool IsDeleted { get; set; }
		bool IsChanged { get; set; }
		
		#endregion 
	}

	/// <summary>
	/// Customer object for NHibernate mapped table 'Customer'.
	/// </summary>
	[Serializable]
	public partial class Customer : ICloneable,ICustomer
	{
		#region Member Variables

		protected int _customerid;
		protected string _firstname;
		protected string _lastname;
		protected int _version;
		protected IList<Order> _orders;
		protected bool _bIsDeleted;
		protected bool _bIsChanged;
		#endregion
		
		#region Constructors
		public Customer() {}
			
		public Customer(string pFirstname, string pLastname, int pVersion)
		{
			this._firstname = pFirstname; 
			this._lastname = pLastname; 
			this._version = pVersion; 
		}
				
		public Customer(int pCustomerId)
		{
			this._customerid = pCustomerId; 
		}
		
		#endregion
		
		#region Public Properties
		
		public virtual int CustomerId
		{
			get { return _customerid; }
			set { _bIsChanged |= (_customerid != value); _customerid = value; }
			
		}
		
		public virtual string Firstname
		{
			get { return _firstname; }
			set 
			{
			  if (value != null && value.Length > 50)
			    throw new ArgumentOutOfRangeException("Firstname", "Firstname value, cannot contain more than 50 characters");
			  _bIsChanged |= (_firstname != value); 
			  _firstname = value; 
			}
			
		}
		
		public virtual string Lastname
		{
			get { return _lastname; }
			set 
			{
			  if (value != null && value.Length > 50)
			    throw new ArgumentOutOfRangeException("Lastname", "Lastname value, cannot contain more than 50 characters");
			  _bIsChanged |= (_lastname != value); 
			  _lastname = value; 
			}
			
		}
		
		public virtual int Version
		{
			get { return _version; }
			set { _bIsChanged |= (_version != value); _version = value; }
			
		}
		
		public virtual OrderCollection Orders_OrderCollection
		{
			get { OrderCollection col = new OrderCollection( _orders ); _orders = col.GetList(); return col; }
			set { _bIsChanged |= (_orders != value); _orders = value.GetList(); }
		}
		
		[System.Xml.Serialization.XmlIgnore]
		public virtual IList<Order> Orders
		{
			get { return _orders; }
			set { _bIsChanged |= (_orders != value); _orders = value; }
			
		}
		

		public bool IsDeleted
		{
			get
			{
				return _bIsDeleted;
			}
			set
			{
				_bIsDeleted = value;
			}
		}
		
		public bool IsChanged
		{
			get
			{
				return _bIsChanged;
			}
			set
			{
				_bIsChanged = value;
			}
		}
		
		#endregion 
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			Customer castObj = null;
			try
			{
				castObj = (Customer)obj;
			} catch(Exception) { return false; } 
			return ( castObj != null ) &&
				( this._customerid == castObj.CustomerId );
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
		  
			
			int hash = 57; 
			hash = 27 * hash * _customerid.GetHashCode();
			return hash; 
		}
		#endregion
		
		#region ICloneable methods
		
		public object Clone()
		{
			return this.MemberwiseClone();
		}
		
		#endregion
				
		#region Public Property and Mapping Constants

		//Nested class to provide strongly-typed access to property names (for .NET databinding, etc.)
		public static class PropertyNames
		{
			public const string Customer = "Customer";			
			public const string CustomerId = "CustomerId";			
			public const string Firstname = "Firstname";			
			public const string Lastname = "Lastname";			
			public const string Version = "Version";
			public const string Orders_OrderCollection = "Orders_OrderCollection";			
			public const string Orders = "Orders";			
		}
		
		//Nested class to provide strongly-typed access to mapping names (for NHibernate Queries, etc.)
		public static class MappingNames
		{
			public const string Customer = "Customer";			
			public const string CustomerId = "CustomerId";			
			public const string Firstname = "Firstname";			
			public const string Lastname = "Lastname";			
			public const string Version = "Version";
			public const string Orders_OrderCollection = "Orders_OrderCollection";			
			public const string Orders = "Orders";			
		}

		#endregion
		
		
	}
	
	#region Custom ICollection interface for Customer 

	
	public interface ICustomerCollection : ICollection
	{
		Customer this[int index]{	get; set; }
		void Add(Customer pCustomer);
		void Clear();
	}
	
	[Serializable]
	public class CustomerCollection : ICustomerCollection
	{
		private IList<Customer> _arrayInternal;

		public CustomerCollection()
		{
			_arrayInternal = new List<Customer>();
		}
		
		public CustomerCollection( IList<Customer> pSource )
		{
			_arrayInternal = pSource;
			if(_arrayInternal == null)
			{
				_arrayInternal = new List<Customer>();
			}
		}

		public Customer this[int index]
		{
			get
			{
				return _arrayInternal[index];
			}
			set
			{
				_arrayInternal[index] = value;
			}
		}

		public int Count { get { return _arrayInternal.Count; } }
		public bool IsSynchronized { get { return false; } }
		public object SyncRoot { get { return _arrayInternal; } }
		public void CopyTo(Array array, int index){ _arrayInternal.CopyTo((Customer[])array, index); }
		public IEnumerator GetEnumerator() { return _arrayInternal.GetEnumerator(); }
		public void Add(Customer pCustomer) { _arrayInternal.Add(pCustomer); }
		public void Clear() { _arrayInternal.Clear(); }
		public IList<Customer> GetList() { return _arrayInternal; }
	 
	
	#endregion
	
	}
}
