/*
Created using Microdesk MyGeneration NHibernate Template v1.1
[based on MyGeneration/Template/NHibernate (c) by Sharp 1.4]
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace DataTransfer
{

	/// <summary>
	/// IOrder interface for NHibernate mapped table 'Order'.
	/// </summary>
	public interface IOrder
	{
		#region Public Properties
		
		int OrderId
		{
			get ;
			set ;
			  
		}
		
		DateTime OrderDate
		{
			get ;
			set ;
			  
		}
		
		Customer Customer
		{
			get ;
			set ;
			  
		}
		
		int Version
		{
			get ;
			set ;
			  
		}
		
		ProductCollection Products_ProductCollection
		{
			get ;
			set ;
		}
		
		
		IList<Product> Products
		{
			get ;
			set ;
			  
		}
		
		bool IsDeleted { get; set; }
		bool IsChanged { get; set; }
		
		#endregion 
	}

	/// <summary>
	/// Order object for NHibernate mapped table 'Order'.
	/// </summary>
	[Serializable]
	public partial class Order : ICloneable,IOrder
	{
		#region Member Variables

		protected int _orderid;
		protected DateTime _orderdate;
		protected Customer _customer;
		protected int _version;
		protected IList<Product> _products;
		protected bool _bIsDeleted;
		protected bool _bIsChanged;
		#endregion
		
		#region Constructors
		public Order() {}
			
		public Order(DateTime pOrderDate, Customer pCustomer, int pVersion)
		{
			this._orderdate = pOrderDate; 
			this._customer = pCustomer; 
			this._version = pVersion; 
		}
				
		public Order(int pOrderId)
		{
			this._orderid = pOrderId; 
		}
		
		#endregion
		
		#region Public Properties
		
		public virtual int OrderId
		{
			get { return _orderid; }
			set { _bIsChanged |= (_orderid != value); _orderid = value; }
			
		}
		
		public virtual DateTime OrderDate
		{
			get { return _orderdate; }
			set { _bIsChanged |= (_orderdate != value); _orderdate = value; }
			
		}
		
		public virtual Customer Customer
		{
			get { return _customer; }
			set { _bIsChanged |= (_customer != value); _customer = value; }
			
		}
		
		public virtual int Version
		{
			get { return _version; }
			set { _bIsChanged |= (_version != value); _version = value; }
			
		}
		
		public virtual ProductCollection Products_ProductCollection
		{
			get { ProductCollection col = new ProductCollection( _products ); _products = col.GetList(); return col; }
			set { _bIsChanged |= (_products != value); _products = value.GetList(); }
		}
		
		[System.Xml.Serialization.XmlIgnore]
		public virtual IList<Product> Products
		{
			get { return _products; }
			set { _bIsChanged |= (_products != value); _products = value; }
			
		}
		

		public bool IsDeleted
		{
			get
			{
				return _bIsDeleted;
			}
			set
			{
				_bIsDeleted = value;
			}
		}
		
		public bool IsChanged
		{
			get
			{
				return _bIsChanged;
			}
			set
			{
				_bIsChanged = value;
			}
		}
		
		#endregion 
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			Order castObj = null;
			try
			{
				castObj = (Order)obj;
			} catch(Exception) { return false; } 
			return ( castObj != null ) &&
				( this._orderid == castObj.OrderId );
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
		  
			
			int hash = 57; 
			hash = 27 * hash * _orderid.GetHashCode();
			return hash; 
		}
		#endregion
		
		#region ICloneable methods
		
		public object Clone()
		{
			return this.MemberwiseClone();
		}
		
		#endregion
				
		#region Public Property and Mapping Constants

		//Nested class to provide strongly-typed access to property names (for .NET databinding, etc.)
		public static class PropertyNames
		{
			public const string Order = "Order";			
			public const string OrderId = "OrderId";			
			public const string OrderDate = "OrderDate";			
			public const string Customer = "Customer";			
			public const string Version = "Version";
			public const string Products_ProductCollection = "Products_ProductCollection";			
			public const string Products = "Products";			
		}
		
		//Nested class to provide strongly-typed access to mapping names (for NHibernate Queries, etc.)
		public static class MappingNames
		{
			public const string Order = "Order";			
			public const string OrderId = "OrderId";			
			public const string OrderDate = "OrderDate";			
			public const string Customer = "Customer";			
			public const string Version = "Version";
			public const string Products_ProductCollection = "Products_ProductCollection";			
			public const string Products = "Products";			
		}

		#endregion
		
		
	}
	
	#region Custom ICollection interface for Order 

	
	public interface IOrderCollection : ICollection
	{
		Order this[int index]{	get; set; }
		void Add(Order pOrder);
		void Clear();
	}
	
	[Serializable]
	public class OrderCollection : IOrderCollection
	{
		private IList<Order> _arrayInternal;

		public OrderCollection()
		{
			_arrayInternal = new List<Order>();
		}
		
		public OrderCollection( IList<Order> pSource )
		{
			_arrayInternal = pSource;
			if(_arrayInternal == null)
			{
				_arrayInternal = new List<Order>();
			}
		}

		public Order this[int index]
		{
			get
			{
				return _arrayInternal[index];
			}
			set
			{
				_arrayInternal[index] = value;
			}
		}

		public int Count { get { return _arrayInternal.Count; } }
		public bool IsSynchronized { get { return false; } }
		public object SyncRoot { get { return _arrayInternal; } }
		public void CopyTo(Array array, int index){ _arrayInternal.CopyTo((Order[])array, index); }
		public IEnumerator GetEnumerator() { return _arrayInternal.GetEnumerator(); }
		public void Add(Order pOrder) { _arrayInternal.Add(pOrder); }
		public void Clear() { _arrayInternal.Clear(); }
		public IList<Order> GetList() { return _arrayInternal; }
	 
	
	#endregion
	
	}
}
