/*
Created using Microdesk MyGeneration NHibernate Template v1.1
[based on MyGeneration/Template/NHibernate (c) by Sharp 1.4]
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace DataTransfer
{

	/// <summary>
	/// IProduct interface for NHibernate mapped table 'Product'.
	/// </summary>
	public interface IProduct
	{
		#region Public Properties
		
		int ProductId
		{
			get ;
			set ;
			  
		}
		
		string Name
		{
			get ;
			set ;
			  
		}
		
		decimal Cost
		{
			get ;
			set ;
			  
		}
		
		int Version
		{
			get ;
			set ;
			  
		}
		
		OrderCollection Orders_OrderCollection
		{
			get ;
			set ;
		}
		
		
		IList<Order> Orders
		{
			get ;
			set ;
			  
		}
		
		bool IsDeleted { get; set; }
		bool IsChanged { get; set; }
		
		#endregion 
	}

	/// <summary>
	/// Product object for NHibernate mapped table 'Product'.
	/// </summary>
	[Serializable]
	public partial class Product : ICloneable,IProduct
	{
		#region Member Variables

		protected int _productid;
		protected string _name;
		protected decimal _cost;
		protected int _version;
		protected IList<Order> _orders;
		protected bool _bIsDeleted;
		protected bool _bIsChanged;
		#endregion
		
		#region Constructors
		public Product() {}
			
		public Product(string pName, decimal pCost, int pVersion)
		{
			this._name = pName; 
			this._cost = pCost; 
			this._version = pVersion; 
		}
				
		public Product(int pProductId)
		{
			this._productid = pProductId; 
		}
		
		#endregion
		
		#region Public Properties
		
		public virtual int ProductId
		{
			get { return _productid; }
			set { _bIsChanged |= (_productid != value); _productid = value; }
			
		}
		
		public virtual string Name
		{
			get { return _name; }
			set 
			{
			  if (value != null && value.Length > 50)
			    throw new ArgumentOutOfRangeException("Name", "Name value, cannot contain more than 50 characters");
			  _bIsChanged |= (_name != value); 
			  _name = value; 
			}
			
		}
		
		public virtual decimal Cost
		{
			get { return _cost; }
			set { _bIsChanged |= (_cost != value); _cost = value; }
			
		}
		
		public virtual int Version
		{
			get { return _version; }
			set { _bIsChanged |= (_version != value); _version = value; }
			
		}
		
		public virtual OrderCollection Orders_OrderCollection
		{
			get { OrderCollection col = new OrderCollection( _orders ); _orders = col.GetList(); return col; }
			set { _bIsChanged |= (_orders != value); _orders = value.GetList(); }
		}
		
		[System.Xml.Serialization.XmlIgnore]
		public virtual IList<Order> Orders
		{
			get { return _orders; }
			set { _bIsChanged |= (_orders != value); _orders = value; }
			
		}
		

		public bool IsDeleted
		{
			get
			{
				return _bIsDeleted;
			}
			set
			{
				_bIsDeleted = value;
			}
		}
		
		public bool IsChanged
		{
			get
			{
				return _bIsChanged;
			}
			set
			{
				_bIsChanged = value;
			}
		}
		
		#endregion 
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			Product castObj = null;
			try
			{
				castObj = (Product)obj;
			} catch(Exception) { return false; } 
			return ( castObj != null ) &&
				( this._productid == castObj.ProductId );
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
		  
			
			int hash = 57; 
			hash = 27 * hash * _productid.GetHashCode();
			return hash; 
		}
		#endregion
		
		#region ICloneable methods
		
		public object Clone()
		{
			return this.MemberwiseClone();
		}
		
		#endregion
				
		#region Public Property and Mapping Constants

		//Nested class to provide strongly-typed access to property names (for .NET databinding, etc.)
		public static class PropertyNames
		{
			public const string Product = "Product";			
			public const string ProductId = "ProductId";			
			public const string Name = "Name";			
			public const string Cost = "Cost";			
			public const string Version = "Version";
			public const string Orders_OrderCollection = "Orders_OrderCollection";			
			public const string Orders = "Orders";			
		}
		
		//Nested class to provide strongly-typed access to mapping names (for NHibernate Queries, etc.)
		public static class MappingNames
		{
			public const string Product = "Product";			
			public const string ProductId = "ProductId";			
			public const string Name = "Name";			
			public const string Cost = "Cost";			
			public const string Version = "Version";
			public const string Orders_OrderCollection = "Orders_OrderCollection";			
			public const string Orders = "Orders";			
		}

		#endregion
		
		
	}
	
	#region Custom ICollection interface for Product 

	
	public interface IProductCollection : ICollection
	{
		Product this[int index]{	get; set; }
		void Add(Product pProduct);
		void Clear();
	}
	
	[Serializable]
	public class ProductCollection : IProductCollection
	{
		private IList<Product> _arrayInternal;

		public ProductCollection()
		{
			_arrayInternal = new List<Product>();
		}
		
		public ProductCollection( IList<Product> pSource )
		{
			_arrayInternal = pSource;
			if(_arrayInternal == null)
			{
				_arrayInternal = new List<Product>();
			}
		}

		public Product this[int index]
		{
			get
			{
				return _arrayInternal[index];
			}
			set
			{
				_arrayInternal[index] = value;
			}
		}

		public int Count { get { return _arrayInternal.Count; } }
		public bool IsSynchronized { get { return false; } }
		public object SyncRoot { get { return _arrayInternal; } }
		public void CopyTo(Array array, int index){ _arrayInternal.CopyTo((Product[])array, index); }
		public IEnumerator GetEnumerator() { return _arrayInternal.GetEnumerator(); }
		public void Add(Product pProduct) { _arrayInternal.Add(pProduct); }
		public void Clear() { _arrayInternal.Clear(); }
		public IList<Product> GetList() { return _arrayInternal; }
	 
	
	#endregion
	
	}
}
